#include "utilities.h"
#include <sddrvs.dat>

#define     BACK_COL_ADR    (VDP2_VRAM_A1 + 0x1fffe)
#define     NBG1_CEL_ADR    (VDP2_VRAM_B0 + 0x00000)
#define     NBG1_COL_ADR    (VDP2_COLRAM  + 0x00200)

Uint16 p_oldInputValue;
Uint16 p_inputValue;

unsigned long p_frameStartTime = 0;

void input_read() {
	p_oldInputValue = p_inputValue;
	
	p_inputValue = ~Smpc_Peripheral[0].data;
}

Uint16 input_isPressed( Uint16 which ) {
	return p_inputValue & which;
}

Uint16 input_isTapped( Uint16 which ) {
	Uint16 wasDownLastFrame = p_oldInputValue & which;
	Uint16 isDownThisFrame = p_inputValue & which;
	
	return isDownThisFrame && !wasDownLastFrame;
}

void input_init() {
	input_read();
	input_read();
}

unsigned int random( unsigned int max ) {
	return (unsigned int) rand() % max;
}

void sound_init() {
    char sound_map[] = { 0xff , 0xff };
    slInitSound( sddrvstsk , sizeof(sddrvstsk) , (Uint8 *)sound_map , sizeof(sound_map) );
}

void Pal2CRAM( Uint16 *Pal_Data, void *Col_Adr, Uint32 Entries ) {
    Uint16 loop;
	Uint16 *VRAM;

	VRAM = (Uint16 *)Col_Adr;

    for (loop = 0; loop < Entries; loop++) {
        *(VRAM++) = *(Pal_Data++);
    }
}

void screen_init() {
	slInitSystem( TV_320x240, NULL, 1 );
	slTVOff();
    slColRAMMode( CRM16_1024 );
    slBack1ColSet( (void *)BACK_COL_ADR, CD_Black );
    slInitBitMap( bmNBG1, BM_512x256, (void *)NBG1_CEL_ADR );
    slBMPaletteNbg1( 1 );
    Pal2CRAM( palette, (void *)NBG1_COL_ADR, 256 );
    slBitMapBase( 0, 0 );
    slScrPosNbg1( toFIXED( 0.0 ), toFIXED( 0.0 ) );
    slScrAutoDisp( NBG0ON | NBG1ON );
    slTVOn();
}

void screen_flip() {
	slSynch();
}

void screen_render( Uint8 img, Rectangle *dest ) {
	slBMPut((dest) == NULL ? 0 : ((Rectangle *)dest)->x, (dest) == NULL ? 0 : ((Rectangle *)dest)->y, ((dest) == NULL ? 0 : ((Rectangle *)dest)->x) + images[img].w - 1, ((dest) == NULL ? 0 : ((Rectangle *)dest)->y) + images[img].h - 1, images[img].data);
}

void itoa( char* s, int x ) {
	char temp[] = "Temporary storage!";
	signed char digits = 0;

	while( x >= 10 ) {
		temp[digits] = '0' + x % 10;
		x = x / 10;
		digits++;
	}

	temp[digits] = '0' + x;

	// copy digits to return string, reversing order
	while(digits >= 0) {
		*s++ = temp[digits];
		digits--;
	}

	// add terminator
	*s = 0;

	// hasta la vista baby!
}
