#ifndef __UTILITIES__H__
#define __UTILITIES__H__

#include <sgl.h>
#include "images.h"

#define LEFT PER_DGT_KL
#define RIGHT PER_DGT_KR
#define UP PER_DGT_KU
#define DOWN PER_DGT_KD
#define BUTTON_A PER_DGT_TA

#define SCREEN_HEIGHT 240
#define SCREEN_WIDTH 320

#define BLACK_STRIP_HEIGHT 30
#define PLAYAREA_TOP BLACK_STRIP_HEIGHT
#define PLAYAREA_BOTTOM (SCREEN_HEIGHT - BLACK_STRIP_HEIGHT)
#define PLAYAREA_MIDDLE (BLACK_STRIP_HEIGHT + (PLAYAREA_BOTTOM - PLAYAREA_TOP)/2 )

void screen_init();
void screen_flip();
void screen_render( Uint8 img, Rectangle *dest );

void sound_init();

void input_init();
void input_read();
Uint16 input_isPressed( Uint16 which );
Uint16 input_isTapped( Uint16 which );

unsigned int random( unsigned int max );
void itoa( char* s, int x );

#endif
